%{
// lex-bassist.l
//
// Created 1998 by Karri-Pekka Laakso
//
// $Modified: Wed Jul 15 14:36:08 1998 kpalaaks$
// $Id: lex-bassist.l,v 1.7 1999/10/26 10:19:41 jks Exp $
//

#include "node.h"
#include "expr.h"
#include "record.h"
#include "variable.h"
#include "implementation.h"
#include <string.h>
#include "parse-bassist.h"

extern "C" int yywrap();

%}


%option yylineno
%%

 /* Handling \240 as whitespace assumes Latin-1, not too bad.
  * (Not handling it did lead to an actual problem when ktv@rni
  * managed to type \240.) 
  */
[ \t\n\240]			{ ; /* Pass them. */ }
#.*\n				{ ; /* Comment to the end of line */ }
(0|[1-9][0-9]*)\.?[0-9]*	{ yylval.f = atof(yytext); return FLOAT; }
model				{ return MODEL; }
var				{ return VAR; }
record				{ return RECORD; }
ref				{ return REF; }
as				{ return AS; }
predicted			{ return PREDICTED; }
distribution			{ return DISTRIBUTION; }
aggr_sum			{ return AGGR_SUM; }
aggr_product			{ return AGGR_PRODUCT; }
aggr_min			{ return AGGR_MIN; }
aggr_max			{ return AGGR_MAX; }
aggr_avg			{ return AGGR_AVG; }
aggr_count			{ return AGGR_COUNT; }
implementation 			{ return IMPLEMENTATION; }
init				{ return INIT; }
prior				{ return PRIOR; }
propose				{ return PROPOSE; }
update				{ return UPDATE; }
ordered				{ return ORDERED; }
unordered			{ return UNORDERED; }
[a-zA-Z_][a-zA-Z0-9_]*		{ yylval.s = strdup(yytext); return ID; }
.				{ return *yytext; }

%%

//-----------------------------//
// Local Variables:            //
// mode: c++                   //
// make-backup-files: t        //
// End:                        //
//-----------------------------//
