// This file exists for documentation purposes

/**
	Composite class is generated during the compilation of the model.
	Composites are variables, whose values 
	are determined deterministic from other variables or functions.	 
	For instance composite c could be determined by mapping f(x,y), 
	where x and y may be some stochastic variables.
*/
class generated_composite : public quantity {

public:
  /**
    Constructor.
    @param *name Name of the composite	
    */
  generated_composite(const string &name);
  
  /**
    Returns current value of this composite
    @return Value of this composite
    */
  double value();

  /**
    For same use as in the class parameter
    @param scanner 
    @param name
    @param inited
    @return
    */
  bool askValue(scanner &, const char *, bool);

  /** 
    Adds given parameter to a list of dependents of this composite
    @param Dependent parameter
    */
  void addDependent(parameter *p);	
};
