// node.h
//
// Created 1998 by Karri-Pekka Laakso
//
// $Id: node.h,v 1.4 1999/08/04 12:05:04 jks Exp $
//

#ifndef NODE_H
#define NODE_H

/** A virtual base class for all the compiler parse tree nodes.

   The current implementation of the node class is extremely
   bare, but in the future it will contain methods to
   examine the type of a parse tree node, which would be needed in
   the code generation. */
    
class parseTreeNode {
public:
    /** Prints the model specification to the standard output.

	Implements a recursive print of the original model
	specification using the parse tree nodes. In order to get the
	whole model syntax printed, it iterates through all the parse
	tree lists and calls this function for each of them.

	This function has no default implementation.
	
	@see compiler::printTree */
    virtual void printCode() = 0;

    /// Virtual destructor since there are other virtual functions
    virtual ~parseTreeNode() {}
};

#endif // NODE_H

// Local Variables:    
// mode: c++           
// c-basic-offset: 4   
// make-backup-files: t
// End:                
