// genRecords.h
//
// Created 1998 by Karri-Pekka Laakso
//
// $Id: genRecords.h,v 1.19 1999/10/22 14:03:11 jks Exp $
//

#ifndef GENRECORDS_H
#define GENRECORDS_H

#include <map>
#include <string>
#include <vector>

#include <cstdlib>
#include <cstdio>
#include <cmath>
using namespace std;

#include "record.h"

#include "common.h"
#include "gen.h"

#include "distributions.h"
#include "quantity.h"
#include "parameter.h"
#include "constant.h"
#include "scanner.h"

#include "genParameters.h" 
#include "genComposites.h"



// Record class definitions

// FOREACH REC (RECORD)
class record_$REC.NAME : public $REC.BASE {
    friend class simulator;

protected:
    static vector<record_$REC.NAME*> *instances;

    typedef map<string, record_$REC.NAME*> instanceMapType;
    static instanceMapType *instanceMap;

public:
    //    static const map<string, record_$REC.NAME> & instances { return *instanceMap; };
    
// FOREACH REF (REC_REFFIELD)
    $REF.POINTER
    char *$REF.VNAMERef;
    
// ENDFOR    

    static vector<record_$REC.NAME*> *giveInstances() { return instances; };
    static intval count() { return instances->size(); };

// FOREACH VAR (REC_OWNVARFIELD)
    $VAR.POINTER

// ENDFOR    
  
// FOREACH VAR (REC_VARFIELD)
    $VAR.AG_IMPL_PROTO

// ENDFOR    

    record_$REC.NAME(const string &n);
    void createVariables();
    void initLinks();
    void initialize();

    static bool readInput(scanner &sc, bool init);


    static record_$REC.NAME *findReference(char *ref);
};


// ENDFOR

#endif // GENRECORDS_H

//-----------------------------//
// Local Variables:            //
// mode: c++                   //
// make-backup-files: t        //
// c-basic-offset: 4	       //
// End:                        //
//-----------------------------//
